unit ISO_8859_2;

interface

uses
  Printers, ClipBrd, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, XPMan;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Edit1: TEdit;
    Shape1: TShape;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1t: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label2t: TLabel;
    Label3t: TLabel;
    Label4t: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    GroupBox3: TGroupBox;
    Label5: TLabel;
    Button3: TButton;
    XPManifest1: TXPManifest;
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure OnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  start_x, start_y: Integer;
  r_x, r_y: Integer;
  pos_x, pos_y: Integer;

implementation

{$R *.dfm}


function IntToOct_snipet(Value: Longint; digits: Integer): string;
var
  rest: Longint;
  oct: string;
  i: Integer;
begin
  oct := '';
  while Value <> 0 do
  begin
    rest  := Value mod 8;
    Value := Value div 8;
    oct := IntToStr(rest) + oct;
  end;
  for i := Length(oct) + 1 to digits do
    oct := '0' + oct;
  Result := oct;
end;

function IntToOct(value: Longint; min_dlzka: Integer): String;
var
  vysledok: String;
begin
  vysledok := '';
  while value > 0 do
  begin
    vysledok := IntToStr(value mod 8) + vysledok;
    value := value div 8;
  end;

  while Length(vysledok) < min_dlzka do
    vysledok := '0' + vysledok;

  Result := vysledok;
end;

function IntToBin_snipet(Value: Longint; Digits: Integer): string;
var
  i: Integer;
begin
  Result := '';
  for i := Digits-1 downto 0 do
    if Value and (1 shl i) <> 0 then
      Result := Result + '1'
  else
    Result := Result + '0';
end;

function IntToBin(value: Longint; min_dlzka: Integer): String;
var
  vysledok: String;
begin
  vysledok := '';
  while value > 0 do
  begin
    vysledok := IntToStr(value mod 2) + vysledok;
    value := value div 2;
  end;

  while min_dlzka > Length(vysledok) do
    vysledok := '0' + vysledok;

  Result := vysledok;
end;

function IntToHexa(value: Longint; min_dlzka: Integer): String;
var
  vysledok: String;
  pole: array [10 .. 15] of Char;
begin
  vysledok := '';
  pole[10] := 'A'; pole[11] := 'B'; pole[12] := 'C'; pole[13] := 'D'; pole[14] := 'E'; pole[15] := 'F';
  while value > 0 do
  begin
    if ((value mod 16) > 9) and ((value mod 16) < 16) then
      vysledok := pole[value mod 16] + vysledok
    else
      vysledok := IntToStr(value mod 16) + vysledok;
    value := value div 16;
  end;

  while min_dlzka > Length(vysledok) do
    vysledok := '0' + vysledok;

  Result := vysledok;
end;

function only_numbers(source: string): String;
var
  i: Integer;
  iba_cisla: String;
begin
  for i := 1 to Length(source) do
  begin
    if (Ord(source[i]) > 47) and (Ord(source[i]) < 58) then
      iba_cisla := iba_cisla + source[i];
  end;

  Result := iba_cisla;
end;


procedure draw_table(vyznac: Integer);
var
  i, x, y, space, start: Integer;
begin
  Form1.Image1.Canvas.FillRect(Form1.Image1.ClientRect);
  start := 10;
  space := 12;
  r_x := 25;
  r_y := 25;
  x := start + r_x + space;
  y := start;

  Form1.Image1.Canvas.Font.Color := RGB(20, 143, 188);
  Form1.Image1.Canvas.Font.Name := 'Courier New';
  Form1.Image1.Canvas.Font.Style := [];
  Form1.Image1.Canvas.Font.Size := 12;

  for i := 1 to 32 do
  begin
    if i <= 16 then
    begin
      Form1.Image1.Canvas.TextOut(x, y, IntTostr(i));
      x := x + r_x;
      if i = 16 then
      begin
        x := start;
        y := y + r_y + space;
      end;
    end
    else if i >= 17 then
    begin
      Form1.Image1.Canvas.TextOut(x, y, IntTostr(i - 16));
      y := y + r_y;
    end;

  end;

  Form1.Image1.Canvas.Font.Color := clBlack;

  x := start + r_x + space;
  y := start + r_y + space;
  start_x := x;
  start_y := y;

  for i := 0 to 255 do
  begin
    Form1.Image1.Canvas.TextOut(x, y, Char(i));

    x := x + r_x;
    if (i + 1) mod 16 = 0 then
    begin
      x := start + r_x + space;
      y := y + r_y;
    end;

  end;

  Form1.Image1.Canvas.Pen.Color := RGB(20, 143, 188);

  Form1.Image1.Canvas.MoveTo(start_x, start_y - space - 1);
  Form1.Image1.Canvas.LineTo(start_x + (16 * r_x), start_y - space - 1);

  Form1.Image1.Canvas.MoveTo(start_x - space - 1 , start_y);
  Form1.Image1.Canvas.LineTo(start_x - space - 1, start_y + (16 * r_y));



  if vyznac >= 0 then
  begin
    x := start_x + ((vyznac - ((vyznac div 16) * 16)) * r_x);
    y := start_y + ((vyznac div 16) * r_y);
    Form1.Image1.Canvas.Font.Size := 18;
    Form1.Image1.Canvas.Font.Style := [fsBold];
    Form1.Image1.Canvas.Brush.Color := RGB(142, 232, 68);
    Form1.Image1.Canvas.Pen.Color := Form1.Image1.Canvas.Brush.Color;
    Form1.Image1.Canvas.Rectangle(x - (r_x div 2), y - (r_y div 2), x + r_x, y + r_y);

    Form1.Image1.Canvas.TextOut(x, y - (r_y div 4), Char(vyznac));

    Form1.Image1.Canvas.Font.Size := 8;
    Form1.Image1.Canvas.Brush.Color := clWhite;
    Form1.Image1.Canvas.Pen.Color := clBlack;
  end;

  start_x := start + r_x + space;
  start_y := start + r_y + space;
end;


procedure move(Key: word);
var
  old_pos_x, old_pos_y: Integer;
begin
  old_pos_x := pos_x;
  old_pos_y := pos_y;

  if (Key = VK_LEFT) and (pos_x > 0) and (pos_x <= 15) then
  begin
    pos_x := pos_x - 1;
  end
  else if (Key = VK_LEFT) and (pos_x = 0) and (pos_y > 0) then
  begin
    pos_x := 15;
    pos_y := pos_y - 1;
  end
  else if (Key = VK_RIGHT) and (pos_x >= 0) and (pos_x < 15) then
  begin
    pos_x := pos_x + 1;
  end
  else if (Key = VK_RIGHT) and (pos_x = 15) and (pos_y < 15) then
  begin
    pos_x := 0;
    pos_y := pos_y + 1;
  end;

  if (Key = VK_UP) and (pos_y > 0) and (pos_y <= 15) then
    pos_y := pos_y - 1
  else if (Key = VK_DOWN) and (pos_y >= 0) and (pos_y < 15) then
    pos_y := pos_y + 1;

  if not(old_pos_x = pos_x) or not(old_pos_y = pos_y) then
  begin
    draw_table((pos_x) + (pos_y) * 16);
    Form1.Label1.Caption := IntToStr((pos_x) + (pos_y) * 16);
    Form1.Label2.Caption := IntToHexa((pos_x) + (pos_y) * 16, 1);
    Form1.Label3.Caption := IntToOct((pos_x) + (pos_y) * 16, 1);
    Form1.Label4.Caption := IntToBin((pos_x) + (pos_y) * 16, 8);
  end;

  Form1.Label5.Caption := 'x: ' + IntToStr(pos_x + 1) + '  y: ' + IntToStr(pos_y + 1);
end;


procedure TForm1.Edit1Change(Sender: TObject);
begin
  Edit1.Text := only_numbers(Edit1.Text);
  Edit1.SelStart := Length(Edit1.Text);

  if (Edit1.Text <> '') and (StrToInt(Edit1.Text) >= 0 ) and (StrToInt(Edit1.Text) <= 255 ) then
  begin
    Label1.Caption := Edit1.Text;
    Label2.Caption := IntToHexa(StrToInt(Edit1.Text), 1);
    Label3.Caption := IntToOct(StrToInt(Edit1.Text), 1);
    Label4.Caption := IntToBin(StrToInt(Edit1.Text), 8);
    draw_table(StrToInt(Edit1.Text));
    pos_x := StrToInt(Edit1.Text) - ((StrToInt(Edit1.Text) div 16) * 16);
    pos_y := (StrToInt(Edit1.Text)) div 16;
  end
  else if (Edit1.Text <> '') and (StrToInt(Edit1.Text) > 255) then
  begin
    Edit1.Text := '255';
    Edit1.SelStart := 3;
    Label1.Caption := Edit1.Text;
    Label2.Caption := IntToHexa(StrToInt(Edit1.Text), 1);
    Label3.Caption := IntToOct(StrToInt(Edit1.Text), 1);
    Label4.Caption := IntToBin(StrToInt(Edit1.Text), 8);
    draw_table(StrToInt(Edit1.Text));
  end
  else if(Edit1.Text <> '') and (StrToInt(Edit1.Text) < 0) then
  begin
    Edit1.Text := '0';
    Edit1.SelStart := 1;
    Label1.Caption := Edit1.Text;
    Label2.Caption := IntToHexa(StrToInt(Edit1.Text), 1);
    Label3.Caption := IntToOct(StrToInt(Edit1.Text), 1);
    Label4.Caption := IntToBin(StrToInt(Edit1.Text), 8);
    draw_table(StrToInt(Edit1.Text));
  end
  else
  begin
    Label1.Caption := '';
    Label2.Caption := '';
    Label3.Caption := '';
    Label4.Caption := '';
    draw_table(-1);
    pos_x := -1;
    pos_y := -1;
  end;

  Form1.Label5.Caption := 'x: ' + IntToStr(pos_x + 1) + '  y: ' + IntToStr(pos_y + 1);
end;


procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  move(Key);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.Left := (Screen.Width) - (Form1.Width);
  Form1.Top := (Screen.Height div 2) - (Form1.Height div 2);

  pos_x := -1;
  pos_y := -1;
  draw_table(-1);
end;


procedure TForm1.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  pos_x := X - start_x + (r_x div 4);
  pos_y := Y - start_y + (r_y div 4);

  if (pos_x >= 0) and (pos_y >= 0) and (pos_y < (r_y * 16)) then
  begin
    pos_x := (pos_x div r_x);
    pos_y := (pos_y div r_y);

    draw_table((pos_x) + (pos_y) * 16);
    Label1.Caption := IntToStr((pos_x) + (pos_y) * 16);
    Label2.Caption := IntToHexa((pos_x) + (pos_y) * 16, 1);
    Label3.Caption := IntToOct((pos_x) + (pos_y) * 16, 1);
    Label4.Caption := IntToBin((pos_x) + (pos_y) * 16, 8);
  end
  else
  begin
    Label1.Caption := '';
    Label2.Caption := '';
    Label3.Caption := '';
    Label4.Caption := '';
    draw_table(-1);
  end;

  Form1.Label5.Caption := 'x: ' + IntToStr(pos_x + 1) + '  y: ' + IntToStr(pos_y + 1);
end;


procedure TForm1.OnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  move(Key);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  printDialog : TPrintDialog;
  ScaleX, ScaleY: Integer;
  RR: TRect;

begin
  // Create a printer selection dialog
  printDialog := TPrintDialog.Create(Form1);

  // If the user has selected a printer (or default), then print!
  if printDialog.Execute then
  begin
    // Use the Printer function to get access to the
    // global TPrinter object.
    // All references below are to the TPrinter object
    with Printer do
    begin
      // Start printing
      BeginDoc;

    try
      ScaleX := GetDeviceCaps(Handle, logPixelsX) div PixelsPerInch;
      ScaleY := GetDeviceCaps(Handle, logPixelsY) div PixelsPerInch;
      // Informationen ber die Auflsung
      // Retrieves information about the Pixels per Inch of the Printer.
      RR := Rect(0, 0, Image1.picture.Width * scaleX, Image1.Picture.Height * ScaleY);
      Canvas.StretchDraw(RR, Image1.Picture.Graphic);
      // An die Auflsung anpassen
      // Stretch to fit

    finally
      EndDoc;   //Methode EndDoc beendet den aktuellen Druckauftrag und schliet die
      // Textdatei-Variable.
      // Steht in finally - um auch bei Abbruch des Druckauftrages Papierausgabe
      // sicherzustellen
     end;

    end;
  end;
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
  if ((pos_x >= 0) and (pos_x <= 15)) and ((pos_y >= 0) and (pos_y <= 15)) then
    Clipboard.AsText := Char((pos_x) + (pos_y) * 16);
end;

end.
